
;  
; 0...+5^
; =127
; /  1600/1800 /
	;list  p=16f876A 
;__16F876A
;	#include <P16F876A.INC>
	#include <P16F873A.INC>
 	__config _HS_OSC & _CP_OFF & _PWRTE_OFF & _WDT_OFF & _LVP_OFF & _BODEN_OFF 

;==========================================
#DEFINE	DIN		PORTB,0	 ;(21) "NO"
#DEFINE	TST		PORTC,0	 ;(11) "=0"
#DEFINE	STB		PORTC,3	 ;(14) " "
#DEFINE	IGN		PORTC,2	 ;(13) 
#DEFINE KNL		PORTC,1	 ;(12)  1-2
#DEFINE	IGB		PORTC,4	 ;(15) "/"
#DEFINE	KRB		PORTA,5	 ;(7) ""
#DEFINE	PXX		PORTA,2	 ;(4) 
#DEFINE	BANK0	BCF	STATUS,RP0  ; 0
#DEFINE	BANK1	BSF	STATUS,RP0  ; 1
#DEFINE TMR1_ON  BSF T1CON,0   ;
#DEFINE TMR1_OFF BCF T1CON,0   ;
#DEFINE TM2_ON  BSF T2CON,2   ;
#DEFINE TM2_OFF BCF T2CON,2   ;
;==========================================
	CBLOCK	0X20
;==========================================
	ON_KL	;/  
	OF_KL	;/  
;------------------------------------------
	S_XX	;/  
	MAX_XX	; /   
	UMAX_XX	;    
;------------------------------------------
	P_DAD	;    
	D_DAD	;   
	U_DAD	;   
	C_DAD	;   
;------------------------------------------
	TTH		; . 
	TTL		; . 
	TRH		;
	TRL		;
	TPH		;
	TPL		;
	T1H		;
	T1h		;
	T1S		;
	T1L		;
	T1Z		;
	NST		;   
	ZDN		;.  
	_OST	;    
	ZUP		;   
	_OSTU	;   
	NOZ	;  
	Z_H		; . 
	Z_H1	;
	Z_L		; . 
	Z_L1	;
	Z_W		;  
	Z_XX	;  
	D_XX	;    
	D_MAX	; . 
	D_MIN	;  
	KU_H	;   
	KU_L	;   
	DAD		;-  
	B_D
	WK		;- 
	N_K
	HK		;-  . 
	B_H
	TK		;-  -
	B_T
	FL		;   (0/1)
			;p0- /
			;1-   1/2
			;2-  /
			;3-.   -/+
			;4-   -/+
			;p5-    /
			;6-1 /
;------------------------------------------
	TN1H	;
	TN1L	;
	TN2H	;
	TN2L	;
	TIHh	;
	TIH		;
	TIL		;
;------------------------------------------
	TMP0	;	
	TMPL	;
	TMPH	;
;------------------------------------------
	cnt		; 
	DB1		; 	
	DB0		; 
	DA1		; 
	DA0		; 
;------------------------------------------
	WTEMP	; 
	STEMP	; ""
;==========================================
	ENDC
;==========================================
	org	0x0FD0
	de	.66	;ON_KL /  
	de	.59	;OF_KL /  
	de	.130;S_XX/  
	de	.90	;MAX_XX  /   
	de	.74	;UMAX_XX     
	de	.14	;
	de	.03	;
	de	.17	;
;------------------------------------------
   Org 0x0FE0	;   
 
   DE 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x00
   DE 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
;------------------------------------------
   Org 0x0FF0
	de	.14
	de	.03
	de	.17
;------------------------------------------
	org 0x0FF8	;  
;------------------------------------------
	de	"876Dvsos"
;==========================================
; Program
    Org 0x0000
;   Reset-Vector
	CLRF	FL
	CLRF	PORTA         ;
	CLRF	PORTC
	GOTO	START
;==========================================
;   Interrupt-Vector
	ORG	0X04	; 
;==========================================
;    
;==========================================
NO
	MOVWF	WTEMP	; .	
	SWAPF	STATUS,W
	MOVWF	STEMP
	BANK0
;------------------------------------------
	BTFSS	PIR1,TMR1IF
	GOTO	T0_T
	INCF	TIHh,F
	BCF		PIR1,TMR1IF
	GOTO	E_INT
T0_T
	BTFSS	INTCON,T0IF;0 ?
	GOTO	$+4		;  -  
I_T1H
	INCF	T1H,F; ,   1 ..
	BCF		INTCON,T0IF;  .
	GOTO	E_INT	; 
;------------------------------------------
TZM
	MOVF	TMR0,W
	CLRF	TMR0
	BTFSC	INTCON,T0IF
	INCF	T1H,F
	MOVWF	T1L
	MOVWF	T1Z
	MOVF	T1H,W
	MOVWF	T1h
	MOVWF	T1S
	BCF		INTCON,T0IF
;------------------------------------------
	MOVF	TPL,W
	SUBWF	T1L,W
	BTFSS	STATUS,C
	INCF	TPH,F
	MOVF	TPH,W
	SUBWF	T1H,W
	BTFSS	STATUS,C
	GOTO	I_NOZ
	MOVLW	.10
	MOVWF	NOZ
	BSF		FL,0
;------------------------------------------
I_NOZ
	BTFSC	FL,0
	INCF	NOZ,F
	RLF		T1L,W
	MOVWF	TPL
	RLF		T1H,W
	MOVWF	TPH
	BCF		STATUS,C
	RRF		T1S,F
	RRF		T1Z,W
	ADDWF	TPL,F
	BTFSC	STATUS,C
	INCF	T1S,F
	MOVF	T1S,W
	ADDWF	TPH,F
	CLRF	T1H
	BCF		INTCON,INTF
;------------------------------------------
E_INT
	SWAPF	STEMP,W
	MOVWF	STATUS
	SWAPF	WTEMP,F
	SWAPF	WTEMP,W    ;. .
	RETFIE
;==========================================
;==========================================
;    
;==========================================
START
	BANK0				;
	MOVLW	B'00100001'  ; MR1=1 
	MOVWF	T1CON        ;
	MOVLW	B'00001011'	;
	MOVWF	T2CON
	MOVLW	B'01110000'  ;
	MOVWF	INTCON
	MOVLW	B'10000000'
	MOVWF	RCSTA
	BANK1
	MOVLW	.15
	MOVWF	SPBRG
	MOVLW	B'00100100'
	MOVWF	TXSTA
	MOVLW	B'00000001'	 ;
	MOVWF	PIE1
	CLRF	PIE2
	MOVLW	B'00111011'  ;
	MOVWF	TRISA        ;
	MOVLW	B'10010001'  ;
	MOVWF	TRISC	     ;
	MOVLW	B'10010011'  ;
	MOVWF	TRISB	     ;
	MOVLW	B'00000100'  ;
	MOVWF	ADCON1 	     ;.  
	MOVLW	B'10010100'	;
	MOVWF	OPTION_REG ;
	BANK0
	BCF		IGN
	clrf		TMPH
	clrf		TMPL
;	BSF		KNL
	MOVLW	.2
	MOVWF	cnt
	DECFSZ	TMPH,F
	GOTO	$-1
	DECFSZ	TMPL,F
	GOTO	$-3
	DECFSZ	cnt,F
	GOTO	$-5
;==========================================
;    
;==========================================
CL_DAD
	MOVLW	B'10000001' ;AN0(RA0)-, .
	MOVWF	ADCON0	;   
;------------------------------------------
;     12   
;------------------------------------------
T_10
	MOVLW	.24
	MOVWF	cnt
	DECFSZ	cnt,F
	GOTO	$-1 	      ;
;------------------------------------------
	BSF		ADCON0,GO   ; 
NOADC         
	BTFSC	ADCON0,GO   ;  ?	
	GOTO	NOADC          ;     	
	MOVF	ADRESH,W     ;	
	MOVWF	D_MIN
	MOVWF	B_D
	MOVWF	TMP0
	SWAPF	TMP0,F
	MOVLW	B'00001111'
	ANDWF	TMP0,F
	BCF		STATUS,C
	RRF		TMP0,W
	ADDWF	TMP0,W
	SUBWF	D_MIN,F	
	MOVLW	.167
	SUBWF	D_MIN,F
	BTFSS	STATUS,C
	CLRF	D_MIN
;------------------------------------------
	CALL	LD_EEPROM
;	CLRF	FL		 ; 
;------------------------------------------
	CLRF	N_K
	CLRF	TK
	CLRF	HK
	BCF		STATUS,C
	RRF		UMAX_XX,W
	MOVWF	Z_XX
	CALL	TRSMT
	BANK1
	BTFSS	TXSTA,TRMT
	GOTO	$-1
	BANK0
	BSF		KNL
	CALL	TRSMT
	BANK1
	BTFSS	TXSTA,TRMT
	GOTO	$-1
	BANK0
	BSF		FL,2
	MOVLW	.254
	MOVWF	TIH
	MOVWF	TIL
	CALL	TRSMT
	BANK1
	BTFSS	TXSTA,TRMT
	GOTO	$-1
	BANK0
	CALL	TRSMT
	BANK1
	BTFSS	TXSTA,TRMT
	GOTO	$-1
	BANK0
;------------------------------------------
	CLRF	FL
	CLRF	TIHh	;
	BSF		PXX	 ; 
;==========================================
;      
;==========================================
L1_0
	MOVLW	.8		;  
	MOVWF	NOZ	;   
	MOVLW	.254
	MOVWF	TPL
	MOVWF	TPH
	MOVWF	TTH
	MOVWF	TTL
;------------------------------------------
	BTFSS	DIN	    ;   
	GOTO	$-1
	BTFSC	DIN	    ;   
	GOTO	$-1
	MOVLW	.2
	MOVWF	cnt
;------------------------------------------
PROP
	BTFSS	DIN	    ;   
	GOTO	$-1
	BTFSC	DIN	    ;   
	GOTO	$-1
	CLRF	TMR0
	CLRF	T1H
	CLRF	T1L
	DECFSZ	cnt,F
	GOTO	PROP
;------------------------------------------
	BCF		INTCON,T0IF
	BCF		INTCON,INTF
	BCF		PIR1,TMR1IF
	BSF		INTCON,GIE	; 
;------------------------------------------
	BTFSS	FL,0	;   ""
	GOTO	$-1
	CLRF	TMR1L
	CLRF	TMR1H
;==========================================
L_0
	BSF		FL,5
	BSF		FL,6
	GOTO	PUP1
;==========================================
RUP1	;N>460rpm
;------------------------------------------
	BTFSS	FL,2	; N<460rpm ->  
	GOTO	PUP1		;  
CHK_FL4
	BTFSC	FL,4
	GOTO	CHK_UP1
	MOVF	NOZ,W
	XORLW	.8
	BTFSC	STATUS,Z
	CALL	LOAD_T2
CHK_UP1
	BTFSC	PIR1,TMR2IF
	CALL	LOAD_T
	MOVF	ZUP,W
	SUBWF	NOZ,W	   ;
	BTFSS	STATUS,C	;
	GOTO	CHK_FL4
	BCF		FL,4		;
	TM2_OFF
R_OUP1
	MOVLW	.8
	MOVWF	cnt
	INCF	ZUP,W
	SUBWF	NOZ,W
	BTFSC	STATUS,C
	GOTO	NAK1
	DECFSZ	cnt,F
	GOTO	$-1
	DECFSZ	_OSTU,F
	GOTO	R_OUP1	;
NAK1
	BCF		IGN		; 
	CALL	TRSMT
;------------------------------------------
PUP1	;N<460rpm
;------------------------------------------
	MOVLW	.11
	SUBWF	NOZ,W;
	BTFSS	STATUS,C;
	GOTO	PUP1        ;
	BCF		IGN	    ;,ZAG="1"
;==========================================
RDN1	;N>460rpm
;------------------------------------------
	BTFSS	FL,2	; N<460rpm ->  
	GOTO	PDN1		;  
	MOVF	ZDN,W
	SUBWF	NOZ,W	   ;
	BTFSS	STATUS,C   ;
	GOTO	$-3        ;
R_ODN1
	INCF	ZDN,W
	SUBWF	NOZ,W
	BTFSC	STATUS,C
	GOTO	$+5
	MOVF	_OST,W
	SUBWF	TMR0,W
	BTFSS	STATUS,C
	GOTO	R_ODN1
	BSF		IGN		;,OUTX="0"
;------------------------------------------
PDN1	;N<460rpm
	MOVLW	.29
	SUBWF	NOZ,W	   ;
	BTFSS	STATUS,C   ;
	GOTO	$-3    ;
	BSF		IGN			;,OUTX="0"
;------------------------------------------
	CALL	_PXX	;
;------------------------------------------
Z_20
	MOVLW	.30
	SUBWF	NOZ,W	;
	BTFSS	STATUS,C;
	GOTO	$-3
	BCF	KNL			;
	NOP
	CALL	T_4_8	;
;==========================================
RUP2	;N>460rpm
	BTFSS	FL,2	; N<460rpm ->  
	GOTO	PUP2		;  
	MOVF	ZUP,W
	SUBWF	NOZ,W	   ;
	BTFSS	STATUS,C   ;
	GOTO	$-3        ;
;------------------------------------------
R_OUP2
	INCF	ZUP,W
	SUBWF	NOZ,W
	BTFSC	STATUS,C
	GOTO	NAK2
	MOVF	_OST,W
	SUBWF	TMR0,W
	BTFSS	STATUS,C
	GOTO	R_OUP2
NAK2
	BCF		IGN		;,ZAG="1"
	CALL	TRSMT
;------------------------------------------
PUP2	;N<460rpm
;------------------------------------------
	MOVLW	.41
	SUBWF	NOZ,W;
	BTFSS	STATUS,C;
	GOTO	$-3        ;
	BCF		IGN	    ;,ZAG="1"
;------------------------------------------
RDN2	;N>570rpm
;------------------------------------------
	BTFSS	FL,2	; N<460rpm ->  
	GOTO	PDN2		;  
	MOVF	ZDN,W
	SUBWF	NOZ,W	   ;
	BTFSS	STATUS,C   ;
	GOTO	$-3        ;
;------------------------------------------
R_ODN2
	INCF	ZDN,W
	SUBWF	NOZ,W
	BTFSC	STATUS,C
	GOTO	$+5
	MOVF	_OST,W
	SUBWF	TMR0,W
	BTFSS	STATUS,C
	GOTO	R_ODN2
	BSF		IGN		;,OUTX="0"
;------------------------------------------
PDN2	;N<570rpm
;------------------------------------------
	MOVLW	.59
	SUBWF	NOZ,W	;
	BTFSS	STATUS,C;
	GOTO	$-3    ;
	BSF		IGN		;,OUTX="0"
	BCF	FL,5
	CALL	_PXX	;
;------------------------------------------
Z_50
	MOVLW	.60
	SUBWF	NOZ,W	;
	BTFSS	STATUS,C   ;
	GOTO	$-3
	BSF	KNL			;
	CLRF	NOZ	;
	CALL	T_4_8	;
	GOTO	RUP1
;==========================================
;  
;==========================================
;     (/) 
;==========================================
T_4_8
	MOVLW	B'10000001' ;AN0-DAD
	MOVWF	ADCON0	;
	TMR1_OFF
	MOVF	TMR1H,W
;	MOVWF	TTH		; 
	MOVWF	TIH 
	MOVF	TMR1L,W	;
;	MOVWF	TTL
	MOVWF	TIL
	MOVLW	.3
	MOVWF	TMR1L
	CLRF	TMR1H
;	BTFSC	PIR1,TMR1IF; 1 
	MOVF	TIHh,F
	BTFSS	STATUS,Z
	BSF		FL,6	; 
	TMR1_ON
	BCF		PIR1,TMR1IF;
;------------------------------------------
	BTFSC	TST	;  "" (0/1)
	BTFSC	FL,5	;/  
	GOTO	_P		;""=0, 1- -
	MOVF	T1h,F
	BTFSC	STATUS,Z
	BTFSC	FL,6
	GOTO	_P
T_UZ
	MOVF	TIL,W
	SUBWF	TTL,F
	BTFSS	STATUS,C
	DECF	TTH,F
	MOVF	TIH,W
	SUBWF	TTH,F
	BTFSS	STATUS,C
	GOTO	ZAMED
USKOR
	BCF		STATUS,C
	RRF		TTH,F
	RRF		TTL,W
	SUBWF	TIL,W
	MOVWF	TTL
	BTFSS	STATUS,C
	INCF	TTH,F
	MOVF	TTH,W
	SUBWF	TIH,W
	MOVWF	TTH
	GOTO	GRAF
ZAMED
	COMF	TTH,F
	COMF	TTL,W
	ADDWF	TIL,W
	MOVWF	TTL
	BTFSC	STATUS,C
	INCF	TTH,F
	MOVF	TTH,W
	ADDWF	TIH,W
	MOVWF	TTH
	BTFSC	STATUS,C
	GOTO	_P
GRAF
	BCF		STATUS,C
	RRF		TTH,F
	RRF		TTL,F
	BCF		STATUS,C
	RRF		TTH,F
	RRF		TTL,F
	GOTO	_RR
;------------------------------------------
;    (<460rpm)
;------------------------------------------
_P
	BCF		FL,2		; " "=0
	BSF		PXX	;  
	BSF		N_K,7	;
	RRF		TIHh,F	;
	RRF		TIH,F	;
	RRF		TIL,F	;
	RRF		TIHh,F	;
	RRF		TIH,F	;
	RRF		TIL,F	;
	RRF		TIHh,F	;
	RRF		TIH,F	;
	RRF		TIL,F	;
	CLRF	TIHh	;
	BSF		FL,2		;
	CALL	TRSMT	;
	BCF		FL,2		;
	BCF		FL,6		;
	MOVF	TIH,W	;
	MOVWF	TTH		;
	MOVF	TIL,W	;
	MOVWF	TTL		;
	RETURN
;==========================================
;   >570 -   
;==========================================
;      
;==========================================
_RR
	BSF		FL,2		; " "=1
	MOVLW	.4
	SUBWF	TTH,W
	BTFSC	STATUS,C
	GOTO	$+3
	CLRW
	CLRF	TTL
	MOVWF	NST
;==========================================
; /     IGN
;==========================================
_T0S
	MOVLW	0X0E
	MOVWF	PCLATH
	MOVF	NST,W
	BTFSC	IGB
	ADDLW	.128
	CALL	CNV_L
	MOVWF	Z_L
	INCF	NST,W
	BTFSC	IGB
	ADDLW	.128
	CALL	CNV_L
	MOVWF	Z_L1
	MOVF	NST,W
	BTFSC	IGB
	ADDLW	.128
	CALL	CNV_H
	MOVWF	Z_H
	INCF	NST,W
	BTFSC	IGB
	ADDLW	.128
	CALL	CNV_H
	MOVWF	Z_H1
	CLRF	PCLATH
;------------------------------------------
	MOVF	TTL,W
	MOVWF	DB0		;
;------------------------------------------
L_ZH
	MOVF	Z_H1,W; Z_H1>Z_H?
	SUBWF	Z_H,W
	MOVWF	DA0		;Z_H-Z_H1->DA0
;------------------------------------------
	BSF		ADCON0,GO
;------------------------------------------
	BTFSS	STATUS,C; -   /
	GOTO	SPAD_H
ROST_H	; Z_H1<Z_H
	CALL	MUL8X8	;  TTL
	MOVF	DA1,W	;  256 
	SUBWF	Z_H,F	;  Z_H1 
	GOTO	L_ZL
SPAD_H	; Z_H1>Z_H
	COMF	DA0,F	;255-(Z_H-Z_H1)
	CALL	MUL8X8
	MOVF	DA1,W
	ADDWF	Z_H,F
;------------------------------------------
L_ZL
	MOVF	Z_L1,W
	SUBWF	Z_L,W
	MOVWF	DA0
	BTFSS	STATUS,C
	GOTO	SPAD_L
ROST_L	; Z_L1<Z_L
	CALL	MUL8X8
	MOVF	DA1,W
	SUBWF	Z_L,F
	GOTO	W_RAZN
SPAD_L	; Z_L1>Z_L
	COMF	DA0,F	;255-(Z_L-Z_L1)
	CALL	MUL8X8
	MOVF	DA1,W
	ADDWF	Z_L,F
;------------------------------------------
W_RAZN
	CALL	ADW
;------------------------------------------
	MOVF	Z_L,W
	SUBWF	Z_H,W
	BTFSS	STATUS,C
	CLRW
	MOVWF	Z_W
;==========================================
;     ""    ""
;==========================================
CHK_XX	;  
	MOVLW	.40
	SUBWF	S_XX,W
	SUBWF	TIH,W
	BTFSS	KRB	;""=1
	BTFSS	STATUS,C;>1100
	GOTO	_VAKN	; ""
;------------------------------------------
_STXX	; ""=850/
	MOVLW	.1
	SUBWF	D_XX,F
	BTFSS	STATUS,C
	CLRF	D_XX
	BTFSS	STATUS,Z
	GOTO	OUT_X
	MOVF	TIH,W
	SUBWF	S_XX,W
	BTFSS	STATUS,C
	GOTO	inc_UOZ
	MOVF	S_XX,W
	SUBWF	TIH,W
	BTFSS	STATUS,C
	GOTO	dec_UOZ
	BSF		STB
	GOTO	OUT_X
;------------------------------------------
inc_UOZ
	INCF	Z_XX,F; 1  
	MOVF	Z_XX,W
	SUBWF	UMAX_XX,W;.   
	BTFSC	STATUS,C;  ,
	GOTO	M_4	; 
	MOVF	UMAX_XX,W;   +22
	MOVWF	Z_XX
	GOTO	M_4;
;------------------------------------------
dec_UOZ
	MOVLW	.1
	SUBWF	Z_XX,F; 1  
	BTFSS	STATUS,C;   
	CLRF	Z_XX	; <0,  0
;------------------------------------------
M_4
	BCF	STB
	MOVF	TIH,W
	SUBWF	S_XX,W
	MOVWF	D_XX
	BTFSS	STATUS,C
	COMF	D_XX,F
	MOVF	D_XX,W
	SUBLW	.7
	BTFSS	STATUS,C
	CLRW
	MOVWF	D_XX
;------------------------------------------
OUT_X
	BSF		PXX	;  
	MOVF	Z_XX,W; " "
	MOVWF	ZDN
	MOVWF	_OST
	GOTO	L_TH
;==========================================
_VAKN
	BCF		STB
	MOVF	Z_W,W
	MOVWF	DA0
	MOVF	N_K,W
	MOVWF	DB0
	CALL	MUL8X8
	RLF		DA0,F
	RLF		DA1,F
	MOVF	DA1,W
	MOVWF	WK
;------------------------------------------
_VYX
	CALL	ADT		;
;------------------------------------------
	MOVF	WK,W	; /
	ADDWF	Z_L,W
	BTFSC	STATUS,C; >255
	MOVLW	.255	; =255
	ADDWF	TK,W	; /
	BTFSC	STATUS,C; > 255
	MOVLW	.255	; =255
	MOVWF	Z_XX
	BTFSS	HK,7
	GOTO	H_MI
H_PL
	BCF		HK,7
	MOVF	HK,W
	ADDWF	Z_XX,W
	BTFSC	STATUS,C
	MOVLW	.255
	BSF		HK,7
	GOTO	E_VYX
H_MI
	MOVF	HK,W
	SUBWF	Z_XX,W
	BTFSS	STATUS,C
	CLRW
E_VYX
	MOVWF	_OST
	MOVWF	ZDN
	MOVWF	Z_XX
	INCF	Z_XX,W
	BTFSC	STATUS,Z
	DECF	Z_XX,F	
;------------------------------------------
L_TH ;
	SWAPF	ZDN,F
	COMF	ZDN,W
	ANDLW	B'00001111'
	ADDLW	.13
	MOVWF	ZDN
	MOVLW	.18
	SUBWF	ZDN,W
	BTFSC	STATUS,C
	BTFSC	STATUS,Z
	MOVLW	.1
	MOVWF	ZUP
	BTFSC	KNL		; 2- 
	GOTO	DOS
	MOVLW	.30
	ADDWF	ZUP,F
	ADDWF	ZDN,F
;------------------------------------------
DOS
	COMF	_OST,W
	ANDLW	B'00001111'
	MOVWF	DA0
	MOVF	T1L,W
	MOVWF	DB0
	CALL	MUL8X8
	SWAPF	DA1,F
	SWAPF	DA0,W
	ANDLW	B'00001111'
	ADDWF	DA1,W
	BTFSC	STATUS,Z
	MOVLW	.1
	MOVWF	_OST
	MOVWF	_OSTU
	MOVF	TIH,W
	MOVWF	TTH
	MOVF	TIL,W
	MOVWF	TTL
	RETURN
;==========================================
;   
;==========================================
_PXX
	BTFSS	KRB
	BTFSS	FL,2
	GOTO	P_ON
	MOVF	TIH,W
	SUBWF	OF_KL,W
	BTFSC	STATUS,C
	BCF		PXX          ; 1800 - 
	MOVF	TIH,W
	SUBWF	ON_KL,W  ;   1600
	BTFSS	STATUS,C
P_ON
	BSF		PXX		 ;  
	RETURN
;==========================================
; TRANSMIT
;==========================================
TRSMT
	MOVLW	.255
	MOVWF	TXREG
	BTFSS	PIR1,TXIF
	GOTO	$-1
	MOVWF	TXREG
;------------------------------------------
	MOVLW	B'10001001';AN1- 
	BTFSC	KNL	;  ,
	MOVLW	B'10011001' ;AN3- 
	MOVWF	ADCON0	;
;------------------------------------------
	INCF	TIH,W
	BTFSC	STATUS,Z
	DECF	TIH,F
	MOVF	TIH,W
	BTFSS	FL,2
	MOVF	ON_KL,W
	btfss	PIR1,TXIF;
	GOTO	$-1
	MOVWF	TXREG
;------------------------------------------
	BSF		ADCON0,GO
;------------------------------------------
	INCF	TIL,W
	BTFSC	STATUS,Z
	DECF	TIL,F
	MOVF	TIL,W
	BTFSS	FL,2
	MOVF	OF_KL,W
	btfss	PIR1,TXIF;
	GOTO	$-1
	MOVWF	TXREG
;------------------------------------------
	MOVF	ADRESH,W
	BTFSC	KNL
	MOVWF	B_H
	BTFSS	KNL
	MOVWF	B_T
;------------------------------------------
	INCF	B_D,W
	BTFSC	STATUS,Z
	DECF	B_D,F
	MOVF	B_D,W
	BTFSS	FL,2
	MOVF	S_XX,W
	btfss	PIR1,TXIF;
	GOTO	$-1
	MOVWF	TXREG
	MOVF	N_K,W
	BCF		N_K,7
	BTFSS	FL,2
	MOVF	UMAX_XX,W
	btfss	PIR1,TXIF;
	GOTO	$-1
	MOVWF	TXREG
	MOVF	Z_XX,W;
	BTFSS	FL,2
	MOVF	P_DAD,W
	btfss	PIR1,TXIF;
	GOTO	$-1
	MOVWF	TXREG
	MOVF	B_T,W
	BTFSS	FL,2
	MOVF	D_DAD,W
	btfss	PIR1,TXIF;
	GOTO	$-1
	MOVWF	TXREG
	MOVF	B_H,W;KU_H,W;B_H,W
	BTFSS	FL,2
	MOVF	U_DAD,W
	btfss	PIR1,TXIF;
	GOTO	$-1
	MOVWF	TXREG
	RETURN
;******************************************
; /  , , ,  
;==========================================
;    
;==========================================
ADW
	MOVF	ADRESH,W
	MOVWF	DAD
	MOVWF	B_D
	INCF	B_D,W
	BTFSC	STATUS,Z
	DECF	B_D,F
;------------------------------------------
MIN_D
	MOVF	D_MIN,W
	SUBWF	DAD,W
	BTFSS	STATUS,C
	CLRW
POROG
	MOVWF	N_K
	MOVLW	.25
	SUBWF	N_K,W
	BTFSC	STATUS,C
	GOTO	D_127
D_32
	RLF	N_K,F
	RLF	N_K,F
	MOVLW	.31
	ADDWF	N_K,F
	RETURN
D_127
	MOVLW	.40
	SUBWF	N_K,W
	BTFSS	STATUS,C
	CLRW
	SUBLW	.127
	BTFSS	STATUS,C
	CLRW
	MOVWF	N_K
	RETURN
;==========================================
;   -
;==========================================
ADT
	BTFSC	KNL
	GOTO	ADH
	INCF	B_T,W
	BTFSC	STATUS,Z
	DECF	B_T,F
	MOVLW	.128	;  ?
	SUBWF	B_T,W
	BTFSS	STATUS,C; ,
	CLRW			; =0
	MOVWF	TK
	BCF	STATUS,C	;  
	RRF	TK,F		;0...+10
	BCF	STATUS,C	;
	RRF	TK,F		;
	MOVLW	.16		; 
	SUBWF	TK,W	;  +5
	BTFSS	STATUS,C
	RETURN
	MOVLW	.15
	MOVWF	TK
	RETURN
;==========================================
;    
;==========================================
ADH
	INCF	B_H,W
	BTFSC	STATUS,Z
	DECF	B_H,F
	BTFSS	B_H,7
	GOTO	H_M
H_P
	MOVLW	.128
	SUBWF	B_H,W
	MOVWF	HK
	BCF		STATUS,C
	RRF		HK,F
	BSF	STATUS,C	;  
	RRF		HK,F;0..+10
	RETURN
H_M
	MOVF	B_H,W
	SUBLW	.127
	MOVWF	HK
	BCF		STATUS,C;  
	RRF		HK,F	;0...-10
	BCF		STATUS,C
	RRF		HK,F
	RETURN
;=============================================
LOAD_T
	INCF	NOZ,F
LOAD_T2
	MOVF	T1L,W
	CLRF	TMR2
	BANK1
	MOVWF	PR2
	BANK0
	TM2_ON
	BCF		PIR1,TMR2IF
	BSF		FL,4
	RETURN
;=============================================
LD_EEPROM
	MOVLW	0X20
	MOVWF	FSR
	MOVLW	.8
	MOVWF	cnt
	BSF		STATUS,RP1
	MOVLW	0x0F
	MOVWF	EEADRH
	MOVLW	0xD0
	MOVWF	EEADR
LD_E01
	BSF		STATUS,RP1
	BANK1
	BSF		EECON1,EEPGD
	BSF		EECON1,RD
	NOP
	NOP
	BCF		EECON1,EEPGD
	BANK0
	MOVF	EEDATA,W
	MOVWF	INDF
	INCF	EEADR,F
	INCF	FSR,F
	BCF		STATUS,RP1
	DECFSZ	cnt,F
	GOTO	LD_E01
	BANK0
	RETURN
;==========================================
;  8-   8-
; DA0*DB0(W)=>DA1.DA0
;------------------------------------------
MUL8X8
	MOVF	DB0,W
	clrf	DA1	;
	rrf		DA0,F;
	btfsc	STATUS,C
	addwf	DA1,F	;
	rrf		DA1,F	;
	rrf		DA0,F	;
	btfsc	STATUS,C
	addwf	DA1,F	;
	rrf		DA1,F	;
	rrf		DA0,F	;
	btfsc	STATUS,C
	addwf	DA1,F	;
	rrf		DA1,F	;
	rrf		DA0,F	;
	btfsc	STATUS,C
	addwf	DA1,F	;
	rrf		DA1,F	;
	rrf		DA0,F	;
	btfsc	STATUS,C
	addwf	DA1,F	;
	rrf		DA1,F	;
	rrf		DA0,F	;
	btfsc	STATUS,C
	addwf	DA1,F	;
	rrf		DA1,F	;
	rrf		DA0,F	;
	btfsc	STATUS,C
	addwf	DA1,F	;
	rrf		DA1,F	;
	rrf		DA0,F	;
	btfsc	STATUS,C
	addwf	DA1,F	;
	rrf		DA1,F	;
	rrf		DA0,F	;
	RETURN			;
;******************************************
;    
;==========================================
	ORG	0XE00;380
CNV_H		;	,
	ADDWF	PCL,F
	RETLW    0x6D	; 6750	43,8	, 0
 	RETLW    0x6D	; 5400	43,8	, 1
	RETLW    0x6A	; 4500	42,7	, 2
	RETLW    0x69	; 3857,1	42,4	, 3
	RETLW    0x65	; 3375	41	, 4
	RETLW    0x61	; 3000	39,6	, 5
	RETLW    0x5A	; 2700	37,1	, 6
	RETLW    0x53	; 2454,5	34,7	, 7
	RETLW    0x4E	; 2250	32,9	, 8
	RETLW    0x49	; 2076,9	31,2	, 9
	RETLW    0x45	; 1928,6	29,8	, 10
	RETLW    0x3F	; 1800	27,7	, 11
	RETLW    0x3A	; 1687,5	25,9	, 12
	RETLW    0x36	; 1588,2	24,5	, 13
	RETLW    0x32	; 1500	23,1	, 14
	RETLW    0x2F	; 1421,1	22,1	, 15
	RETLW    0x2D	; 1350	21,4	, 16
	RETLW    0x2B	; 1285,7	20,7	, 17
	RETLW    0x27	; 1227,3	19,3	, 18
	RETLW    0x25	; 1173,9	18,6	, 19
	RETLW    0x22	; 1125	17,5	, 20
	RETLW    0x20	; 1080	16,8	, 21
	RETLW    0x1D	; 1038,5	15,8	, 22
	RETLW    0x1C	; 1000	15,4	, 23
	RETLW    0x1B	; 964,3	15,1	, 24
	RETLW    0x1B	; 931	15,1	, 25
	RETLW    0x19	; 900	14,4	, 26
	RETLW    0x19	; 871	14,4	, 27
	RETLW    0x18	; 843,8	14	, 28
	RETLW    0x18	; 818,2	14	, 29
	RETLW    0x17	; 794,1	13,7	, 30
	RETLW    0x17	; 771,4	13,7	, 31
	RETLW    0x17	; 750	13,7	, 32
	RETLW    0x17	; 729,7	13,7	, 33
	RETLW    0x16	; 710,5	13,3	, 34
	RETLW    0x16	; 692,3	13,3	, 35
	RETLW    0x15	; 675	13	, 36
	RETLW    0x14	; 658,5	12,6	, 37
	RETLW    0x13	; 642,9	12,3	, 38
	RETLW    0x12	; 627,9	11,9	, 39
	RETLW    0x11	; 613,6	11,6	, 40
	RETLW    0x11	; 600	11,6	, 41
	RETLW    0x10	; 587	11,2	, 42
	RETLW    0x0F	; 574,5	10,9	, 43
	RETLW    0x0F	; 562,5	10,9	, 44
	RETLW    0x0E	; 551	10,5	, 45
	RETLW    0x0D	; 540	10,2	, 46
	RETLW    0x0D	; 529,4	10,2	, 47
	RETLW    0x0C	; 519,2	9,8	, 48
	RETLW    0x0B	; 509,4	9,5	, 49
	RETLW    0x0B	; 500	9,5	, 50
	RETLW    0x0A	; 490,9	9,1	, 51
	RETLW    0x09	; 482,1	8,8	, 52
	RETLW    0x08	; 473,7	8,4	, 53
	RETLW    0x07	; 465,5	8,1	, 54
	RETLW    0x06	; 457,6	7,7	, 55
	RETLW    0x05	; 450	7,4	, 56
	RETLW    0x04	; 442,6	7	, 57
	RETLW    0x03	; 435,5	6,7	, 58
	RETLW    0x03	; 428,6	6,7	, 59
	RETLW    0x02	; 421,9	6,3	, 60
;==========================================
;   
;==========================================
 	ORG	0XE40;3C0
CNV_L				;	,
	ADDWF	PCL,F
	RETLW    0x53	; 6750	34,7	, 0
	RETLW    0x53	; 5400	34,7	, 1
	RETLW    0x49	; 4500	31,2	, 2
	RETLW    0x41	; 3857,1	28,4	, 3
	RETLW    0x3A	; 3375	25,9	, 4
	RETLW    0x35	; 3000	24,2	, 5
	RETLW    0x2B	; 2700	20,7	, 6
	RETLW    0x24	; 2454,5	18,2	, 7
	RETLW    0x1E	; 2250	16,1	, 8
	RETLW    0x1B	; 2076,9	15,1	, 9
	RETLW    0x17	; 1928,6	13,7	, 10
	RETLW    0x15	; 1800	13	, 11
	RETLW    0x14	; 1687,5	12,6	, 12
	RETLW    0x13	; 1588,2	12,3	, 13
	RETLW    0x11	; 1500	11,6	, 14
	RETLW    0x10	; 1421,1	11,2	, 15
	RETLW    0x0F	; 1350	10,9	, 16
	RETLW    0x0F	; 1285,7	10,9	, 17
	RETLW    0x0E	; 1227,3	10,5	, 18
	RETLW    0x0E	; 1173,9	10,5	, 19
	RETLW    0x0D	; 1125	10,2	, 20
	RETLW    0x0D	; 1080	10,2	, 21
	RETLW    0x0D	; 1038,5	10,2	, 22
	RETLW    0x0D	; 1000	10,2	, 23
	RETLW    0x0C	; 964,3	9,8	, 24
	RETLW    0x0C	; 931	9,8	, 25
	RETLW    0x0C	; 900	9,8	, 26
	RETLW    0x0C	; 871	9,8	, 27
	RETLW    0x0B	; 843,8	9,5	, 28
	RETLW    0x0B	; 818,2	9,5	, 29
	RETLW    0x0B	; 794,1	9,5	, 30
	RETLW    0x0B	; 771,4	9,5	, 31
	RETLW    0x0A	; 750	9,1	, 32
	RETLW    0x0A	; 729,7	9,1	, 33
	RETLW    0x0A	; 710,5	9,1	, 34
	RETLW    0x0A	; 692,3	9,1	, 35
	RETLW    0x09	; 675	8,8	, 36
	RETLW    0x09	; 658,5	8,8	, 37
	RETLW    0x09	; 642,9	8,8	, 38
	RETLW    0x08	; 627,9	8,4	, 39
	RETLW    0x08	; 613,6	8,4	, 40
	RETLW    0x08	; 600	8,4	, 41
	RETLW    0x07	; 587	8,1	, 42
	RETLW    0x07	; 574,5	8,1	, 43
	RETLW    0x07	; 562,5	8,1	, 44
	RETLW    0x06	; 551	7,7	, 45
	RETLW    0x06	; 540	7,7	, 46
	RETLW    0x06	; 529,4	7,7	, 47
	RETLW    0x05	; 519,2	7,4	, 48
	RETLW    0x05	; 509,4	7,4	, 49
	RETLW    0x05	; 500	7,4	, 50
	RETLW    0x05	; 490,9	7,4	, 51
	RETLW    0x04	; 482,1	7	, 52
	RETLW    0x04	; 473,7	7	, 53
	RETLW    0x03	; 465,5	6,7	, 54
	RETLW    0x03	; 457,6	6,7	, 55
	RETLW    0x03	; 450	6,7	, 56
	RETLW    0x03	; 442,6	6,7	, 57
	RETLW    0x02	; 435,5	6,3	, 58
	RETLW    0x02	; 428,6	6,3	, 59
	RETLW    0x02	; 421,9	6,3	, 60
;==========================================
;    _2
;==========================================
	ORG	0XE80
CNV_H2		;	,
	ADDWF	PCL,F
	RETLW    0x7E	; 6750	49,7	, 0
 	RETLW    0x7E	; 5400	49,7	, 1
	RETLW    0x7B	; 4500	48,7	, 2
	RETLW    0x7A	; 3857,1	48,3	, 3
	RETLW    0x76	; 3375	46,9	, 4
	RETLW    0x73	; 3000	45,9	, 5
	RETLW    0x6B	; 2700	43,1	, 6
	RETLW    0x65	; 2454,5	41	, 7
	RETLW    0x5F	; 2250	38,9	, 8
	RETLW    0x5A	; 2076,9	37,1	, 9
	RETLW    0x56	; 1928,6	35,7	, 10
	RETLW    0x50	; 1800	33,6	, 11
	RETLW    0x4B	; 1687,5	31,9	, 12
	RETLW    0x47	; 1588,2	30,5	, 13
	RETLW    0x43	; 1500	29,1	, 14
	RETLW    0x41	; 1421,1	28,4	, 15
	RETLW    0x3E	; 1350	27,3	, 16
	RETLW    0x3C	; 1285,7	26,6	, 17
	RETLW    0x39	; 1227,3	25,6	, 18
	RETLW    0x36	; 1173,9	24,5	, 19
	RETLW    0x33	; 1125	23,5	, 20
	RETLW    0x31	; 1080	22,8	, 21
	RETLW    0x2F	; 1038,5	22,1	, 22
	RETLW    0x2D	; 1000	21,4	, 23
	RETLW    0x2D	; 964,3	21,4	, 24
	RETLW    0x2C	; 931	21	, 25
	RETLW    0x2B	; 900	20,7	, 26
	RETLW    0x2A	; 871	20,3	, 27
	RETLW    0x29	; 843,8	20	, 28
	RETLW    0x29	; 818,2	20	, 29
	RETLW    0x28	; 794,1	19,6	, 30
	RETLW    0x28	; 771,4	19,6	, 31
	RETLW    0x28	; 750	19,6	, 32
	RETLW    0x27	; 729,7	19,3	, 33
	RETLW    0x27	; 710,5	19,3	, 34
	RETLW    0x27	; 692,3	19,3	, 35
	RETLW    0x26	; 675	18,9	, 36
	RETLW    0x25	; 658,5	18,6	, 37
	RETLW    0x24	; 642,9	18,2	, 38
	RETLW    0x23	; 627,9	17,9	, 39
	RETLW    0x23	; 613,6	17,9	, 40
	RETLW    0x22	; 600	17,5	, 41
	RETLW    0x21	; 587	17,2	, 42
	RETLW    0x20	; 574,5	16,8	, 43
	RETLW    0x20	; 562,5	16,8	, 44
	RETLW    0x1F	; 551	16,5	, 45
	RETLW    0x1E	; 540	16,1	, 46
	RETLW    0x1E	; 529,4	16,1	, 47
	RETLW    0x1D	; 519,2	15,8	, 48
	RETLW    0x1D	; 509,4	15,8	, 49
	RETLW    0x1C	; 500	15,4	, 50
	RETLW    0x1B	; 490,9	15,1	, 51
	RETLW    0x1A	; 482,1	14,7	, 52
	RETLW    0x19	; 473,7	14,4	, 53
	RETLW    0x18	; 465,5	14	, 54
	RETLW    0x17	; 457,6	13,7	, 55
	RETLW    0x16	; 450	13,3	, 56
	RETLW    0x15	; 442,6	13	, 57
	RETLW    0x15	; 435,5	13	, 58
	RETLW    0x14	; 428,6	12,6	, 59
	RETLW    0x13	; 421,9	12,3	, 60
;==========================================
;   _2
;==========================================
 	ORG	0XEC0
CNV_L2				;	,
	ADDWF	PCL,F
	RETLW    0x65	; 6750	41	, 0
	RETLW    0x65	; 5400	41	, 1
	RETLW    0x5A	; 4500	37,1	, 2
	RETLW    0x52	; 3857,1	34,3	, 3
	RETLW    0x4B	; 3375	31,9	, 4
	RETLW    0x46	; 3000	30,1	, 5
	RETLW    0x3D	; 2700	27	, 6
	RETLW    0x35	; 2454,5	24,2	, 7
	RETLW    0x2F	; 2250	22,1	, 8
	RETLW    0x2C	; 2076,9	21	, 9
	RETLW    0x29	; 1928,6	20	, 10
	RETLW    0x27	; 1800	19,3	, 11
	RETLW    0x25	; 1687,5	18,6	, 12
	RETLW    0x24	; 1588,2	18,2	, 13
	RETLW    0x22	; 1500	17,5	, 14
	RETLW    0x21	; 1421,1	17,2	, 15
	RETLW    0x21	; 1350	17,2	, 16
	RETLW    0x20	; 1285,7	16,8	, 17
	RETLW    0x1F	; 1227,3	16,5	, 18
	RETLW    0x1F	; 1173,9	16,5	, 19
	RETLW    0x1F	; 1125	16,5	, 20
	RETLW    0x1E	; 1080	16,1	, 21
	RETLW    0x1E	; 1038,5	16,1	, 22
	RETLW    0x1E	; 1000	16,1	, 23
	RETLW    0x1E	; 964,3	16,1	, 24
	RETLW    0x1E	; 931	16,1	, 25
	RETLW    0x1E	; 900	16,1	, 26
	RETLW    0x1D	; 871	15,8	, 27
	RETLW    0x1D	; 843,8	15,8	, 28
	RETLW    0x1D	; 818,2	15,8	, 29
	RETLW    0x1D	; 794,1	15,8	, 30
	RETLW    0x1C	; 771,4	15,4	, 31
	RETLW    0x1C	; 750	15,4	, 32
	RETLW    0x1B	; 729,7	15,1	, 33
	RETLW    0x1B	; 710,5	15,1	, 34
	RETLW    0x1B	; 692,3	15,1	, 35
	RETLW    0x1B	; 675	15,1	, 36
	RETLW    0x1A	; 658,5	14,7	, 37
	RETLW    0x1A	; 642,9	14,7	, 38
	RETLW    0x19	; 627,9	14,4	, 39
	RETLW    0x19	; 613,6	14,4	, 40
	RETLW    0x19	; 600	14,4	, 41
	RETLW    0x19	; 587	14,4	, 42
	RETLW    0x18	; 574,5	14	, 43
	RETLW    0x17	; 562,5	13,7	, 44
	RETLW    0x17	; 551	13,7	, 45
	RETLW    0x17	; 540	13,7	, 46
	RETLW    0x16	; 529,4	13,3	, 47
	RETLW    0x15	; 519,2	13	, 48
	RETLW    0x15	; 509,4	13	, 49
	RETLW    0x15	; 500	13	, 50
	RETLW    0x14	; 490,9	12,6	, 51
	RETLW    0x14	; 482,1	12,6	, 52
	RETLW    0x13	; 473,7	12,3	, 53
	RETLW    0x13	; 465,5	12,3	, 54
	RETLW    0x12	; 457,6	11,9	, 55
	RETLW    0x12	; 450	11,9	, 56
	RETLW    0x11	; 442,6	11,6	, 57
	RETLW    0x11	; 435,5	11,6	, 58
	RETLW    0x10	; 428,6	11,2	, 59
	RETLW    0x10	; 421,9	11,2	, 60
;==========================================
;	ORG	0X0400
;==========================================
    End

 
 ;       -  div_H  div_M  div_L  
 ;      -  del   
 ;          -  count   
 ;       -  div_H  div_M  div_L  
 ;       -  TMP0   
     
  ;***********************************************************   
  delim 
                  movlw        0xA0   ;  2 500 000 .  
                  movwf        div_L  
                  movlw        0x25  
                  movwf        div_M  
                  movlw        0x26   
                  movwf        div_H  
                  movlw        0x37  
                  movwf        del    ;55 
  
 DEL24_8          CLRF         TMP0              
                  MOVLW        d'24'  
                  MOVWF        count     
 m_1              RLF          div_L,W         
                  RLF          div_M       
                  RLF          div_H       
                  RLF          TMP0          
                  RLF          div_L            
                  MOVF         del,W         
                  SUBWF        TMP0             
                  BTFSC        STATUS,0        
                  BSF          div_L,0                           
                  BTFSS        div_L,0        
                  ADDWF        TMP0           
                  DECFSZ       count  
                  GOTO         m_1
                  RETURN 
;==========================================
;  16    8 
; : DA1.DA0\DB0 => DA1.DA0   TMPL
;------------------------------------------
_DIV1608
;  
	MOVF	DB0, F
	btfsc	STATUS, Z
	retlw	.1	;  (-   0)
	comf	DB0,W	; sub1608
	addlw	.1
	movwf	DB1 
	clrf	TMPL
	clrf	TMP0
	movlw	.16
	movwf	cnt
	bcf		STATUS, C
; 
L1D1608
	clrf	TMPH
	rlf		DA0,W
	rlf		DA1,W
	rlf		TMPL,W
	movwf	TMPL
	rlf		TMP0,F
	movf	DB1,W
	addwf	TMPL,F
	rlf		TMPH,F
	movf	TMPH,W
	addwf	TMP0,F
	movlw	0xFF
	addwf	TMP0,F
	btfsc	STATUS,C
	goto	L2D1608          
	movf	DB1, W
	subwf	TMPL,F
	clrf	TMP0
	bcf		STATUS,C
L2D1608
	rlf		DA0,W
	movwf	DA0
	rlf		DA1,F
	decfsz	cnt,F
	goto	L1D1608
	retlw	.0	; 
;==========================================
;==========================================
;  16    8 
; DA1.DA0 * DB0=> DA2.DA1.DA0
;------------------------------------------
_MUL1608
    CLRF TMPH
    CLRF TMPL
    CLRF TMP0
    MOVLW 0x08           ;   b'00001000'  d'008'
    MOVWF cnt
L1M1608
    RLF TMP0,F
    RLF TMPL,F
    RLF TMPH,F
    BCF TMP0,0
    BTFSS DB0,7
    GOTO L2M1608
    MOVF DA0,W
    ADDWF TMP0,F
    BTFSC STATUS,C
    INCF TMPL,F
    MOVF DA1,W
    ADDWF TMPL,F
    BTFSC STATUS,C
    INCF TMPH,F
L2M1608
    RLF DB0,F
    DECFSZ cnt,F
    GOTO L1M1608
    MOVF TMPL,W
    MOVWF DA0
    MOVF TMPH,W
    MOVWF DA1
    RETURN
;==========================================
;***************************************************************************
;**  time efficient multiplication 8 bit x 8 bit = 16 bit (unsigned)
;**
;**  company:       elektronik 21 GmbH
;**  programmer:            Martin Schaefer (idea from Andrew Warren)
;**
;**  execution time:  fixed 38 cycles  (with jump in and jump out) !!!
;**  code length:           35 words
;**  multiplier:            w
;**  multiplicand:    resultlo
;**  result:        resulthi:resultlo
;***************************************************************************
MUL8X8   CODE
Mul8x8                          ;* 2 cycles for call - instruction
        GLOBAL Mul8x8, resulthi, resultlo

mult    MACRO
        btfsc   STATUS,C
        addwf   resulthi,F
        rrf     resulthi,F
        rrf     resultlo,F
        ENDM

        clrf    resulthi                ;* 1 cycle
        rrf     resultlo,F              ;* 1 cycle

        mult                            ;* 4 cycles
        mult                            ;* 4 cycles
        mult                            ;* 4 cycles
        mult                            ;* 4 cycles
        mult                            ;* 4 cycles
        mult                            ;* 4 cycles
        mult                            ;* 4 cycles
        mult                            ;* 4 cycles

        retlw 0                 ;* 2 cycles
;==========================================
;  8-   8-
; DA0*DB0(W)=>DA1.DA0
;------------------------------------------
MUL8X8
	clrf	DA1	;
	rrf		DA0,F;
	btfsc	STATUS,C
	addwf	DA1,F	;
	rrf		DA1,F	;
	rrf		DA0,F	;
	btfsc	STATUS,C
	addwf	DA1,F	;
	rrf		DA1,F	;
	rrf		DA0,F	;
	btfsc	STATUS,C
	addwf	DA1,F	;
	rrf		DA1,F	;
	rrf		DA0,F	;
	btfsc	STATUS,C
	addwf	DA1,F	;
	rrf		DA1,F	;
	rrf		DA0,F	;
	btfsc	STATUS,C
	addwf	DA1,F	;
	rrf		DA1,F	;
	rrf		DA0,F	;
	btfsc	STATUS,C
	addwf	DA1,F	;
	rrf		DA1,F	;
	rrf		DA0,F	;
	btfsc	STATUS,C
	addwf	DA1,F	;
	rrf		DA1,F	;
	rrf		DA0,F	;
	btfsc	STATUS,C
	addwf	DA1,F	;
	rrf		DA1,F	;
	rrf		DA0,F	;
	RETURN			;
;==========================================
 921600,     ,    2* ,     
 2**(1/921600) -    ,    60/(2*(1/921600)) ,   27648000/ -    .     27648000/65535=421,8.
     ,      , ..   6000    0,3 /.
